import Coordinate from "./Coordinate.js";
import { Emitter } from "./Emitter.js";
import TicTac3DGameManager from "./GameManager.js";
export declare type PlayerSignature = {
    playerIndex: 0 | 1;
};
export default class TicTac3DController extends Emitter<{
    ready: {
        readyState: true;
    };
    currentPlayerChange: {
        newPlayer: PlayerSignature;
    };
    win: {
        player: PlayerSignature;
    };
}> {
    private readonly gameManager;
    private currentPlayer;
    playerWon: PlayerSignature | undefined;
    constructor();
    private setNextCurrentPlayer;
    get CurrentPlayer(): PlayerSignature;
    makeMove(coordinate: Coordinate): boolean;
    get GameManager(): TicTac3DGameManager;
}
