import { Emitter } from "./Emitter.js";
import TicTac3DGameManager from "./GameManager.js";
export default class TicTac3DController extends Emitter {
    gameManager = new TicTac3DGameManager();
    currentPlayer = { playerIndex: 0 };
    playerWon = undefined;
    constructor() {
        super();
        this.emit("ready", { readyState: true });
    }
    setNextCurrentPlayer() {
        this.currentPlayer =
            this.currentPlayer.playerIndex === 0
                ? { playerIndex: 1 }
                : { playerIndex: 0 };
        this.emit("currentPlayerChange", { newPlayer: this.currentPlayer });
    }
    get CurrentPlayer() {
        return this.currentPlayer;
    }
    makeMove(coordinate) {
        const acknowledged = this.gameManager.setItem(coordinate, this.currentPlayer);
        if (acknowledged) {
            this.setNextCurrentPlayer();
        }
        const win = this.gameManager.checkForWin();
        if (win !== undefined) {
            this.playerWon = win;
            this.emit("win", { player: win });
        }
        return acknowledged;
    }
    get GameManager() { return this.gameManager; }
    ;
}
