import Coordinate from "./Coordinate.js";
import GridItem from "./GridItem.js";
export default class TicTac3DGameManager {
    grid = [
        [
            [new GridItem(), new GridItem(), new GridItem()],
            [new GridItem(), new GridItem(), new GridItem()],
            [new GridItem(), new GridItem(), new GridItem()],
        ],
        [
            [new GridItem(), new GridItem(), new GridItem()],
            [new GridItem(), new GridItem(), new GridItem()],
            [new GridItem(), new GridItem(), new GridItem()],
        ],
        [
            [new GridItem(), new GridItem(), new GridItem()],
            [new GridItem(), new GridItem(), new GridItem()],
            [new GridItem(), new GridItem(), new GridItem()],
        ],
    ];
    get Grid() { return this.grid; }
    logGrid() {
        console.log(this.grid[0]);
        console.log(this.grid[1]);
        console.log(this.grid[2]);
    }
    gridGetXSlice(x) {
        const grid = [[], [], []];
        for (let i = 0; i < 3; i++) {
            for (let j = 0; j < 3; j++) {
                grid[i][j] = this.grid[i][j][x];
            }
        }
        return grid;
    }
    gridGetYSlice(y) {
        const grid = [[], [], []];
        for (let i = 0; i < 3; i++) {
            for (let j = 0; j < 3; j++) {
                grid[i][j] = this.grid[i][y][j];
            }
        }
        return grid;
    }
    getItem(c) {
        return this.grid[c.Z][c.Y][c.X];
    }
    setItem(c, value) {
        const item = this.getItem(c);
        if (item.occupiedBy !== undefined)
            return false;
        item.occupiedBy = { ...value };
        return true;
    }
    checkSlice(slice) {
        for (const row of slice) {
            const foundWin = GridItem.compare(row[0], row[1], row[2]);
            if (foundWin)
                return row[0].occupiedBy;
        }
        for (const i of Coordinate.row()) {
            const foundWin = GridItem.compare(slice[0][i], slice[1][i], slice[2][i]);
            if (foundWin)
                return slice[0][i].occupiedBy;
        }
        const foundCross1 = GridItem.compare(slice[0][0], slice[1][1], slice[2][2]);
        if (foundCross1)
            return slice[1][1].occupiedBy;
        const foundCross2 = GridItem.compare(slice[2][0], slice[1][1], slice[0][2]);
        if (foundCross2)
            return slice[1][1].occupiedBy;
        return undefined;
    }
    checkForWin() {
        for (let z = 0; z < 3; z++) {
            const isWin = this.checkSlice(this.grid[z]);
            if (isWin)
                return isWin;
        }
        for (let x = 0; x < 3; x++) {
            const slice = this.gridGetXSlice(x);
            const isWin = this.checkSlice(slice);
            if (isWin)
                return isWin;
        }
        for (let y = 0; y < 3; y++) {
            const isWin = this.checkSlice(this.gridGetYSlice(y));
            if (isWin)
                return isWin;
        }
        return undefined;
    }
}
